/* $Id: fileindex.h,v 1.6 2004/09/10 21:18:29 mis Exp $ */
#ifndef POLDEK_FILEINDEX_H
#define POLDEK_FILEINDEX_H

#include <trurl/nhash.h>
#include <trurl/nmalloc.h>

#include "pkgfl.h"

struct file_index {
    tn_hash   *dirs;             /* dirname => tn_array *files */
    tn_alloc  *na;
};

int  file_index_init(struct file_index *fi, int nelem);
void file_index_destroy(struct file_index *fi);

void file_index_setup(struct file_index *fi); 

void *file_index_add_dirname(struct file_index *fi, const char *dirname);


int file_index_add_basename(struct file_index *fi, void *fidx_dir,
                            struct flfile *flfile,
                            struct pkg *pkg);

void file_index_setup_idxdir(void *fdn);

int file_index_remove(struct file_index *fi, const char *dirname,
                      const char *basename,
                      struct pkg *pkg);

int file_index_lookup(struct file_index *fi,
                      const char *apath, int apath_len, 
                      struct pkg *pkgs[], int size);

int file_index_find_conflicts(const struct file_index *fi, tn_array *errs,
                              int strict);

#endif /* POLDEK_FILEINDEX_H */
    
    
